
#ifndef	__PROCESS_H__
#define	__PROCESS_H__

#include "processor.h"
#include "page.h"


/* declare process's statements... */
#define	PROCESS_RUNNING				1
#define	PROCESS_INTERRUPTIBLE		2
#define	PROCESS_UNINTERRUPTIBLE		3
#define	PROCESS_STOPPED				4


#define MAX_TASK 5

#define	PROCESS_STACK_SIZE	PAGE_SIZE


#define	INIT_PID	0


#define INIT_ADDR			0x40000000
#define INIT_PCB			0x40001000


/* process table... */
typedef struct _task_struct
{
	int	status;
	int	pid;
	char name[16];
	
	unsigned int priority;
	unsigned int counter;

	unsigned int sleep;

	unsigned int task_addr;

	thread_struct thread;
	
} task_struct;



/*
 * Process Control Block
 * It maintains all of information about user process
 * & kernel mode stack
 */
typedef union _task_union
{
	task_struct	task;

	unsigned char	stack[ PROCESS_STACK_SIZE ];
} task_union;

void start_init(void);
void init_process(void);

void init_task_table(void);
int add_task_table(task_struct *new);
int del_task_table(int);


void init_cpu_tss(void);
int create_task(void (*)(void), unsigned int, unsigned int, char *);

#endif
