#include "timer.h"
#include "console.h"

#include "sched.h"


char timer_msg[4] = {'-', '\\', '|', '/'};
unsigned long timer_count;
unsigned short timer_interval;

void init_timer(void)
{
	caos_printf("Initialize timer..");

	/* 
	 * Timer hardware initializing must be added here 
	 */

	timer_interval = 0xffff; // maximum interval
	outb(0x43, 0x34);
	outb(0x40, (unsigned char)(timer_interval & 0xff));
	outb(0x40, (unsigned char)((timer_interval>>8) & 0xff));


	register_irq(0, timer_isr);
	enable_irq(0);

	timer_count = 0;

	caos_printf("OK\n");
}

void timer_isr(void)
{

	/* 
	 * Timer hardware configuration must be added here 
	 */

	timer_count++;

	*(VRAM+ONECHAR_SIZE*70) = 'R';
	*(VRAM+ONECHAR_SIZE*71) = 'U';
	*(VRAM+ONECHAR_SIZE*72) = 'N';
	*(VRAM+ONECHAR_SIZE*73) = '[';
	*(VRAM+ONECHAR_SIZE*74) = timer_msg[timer_count%4];
	*(VRAM+ONECHAR_SIZE*75) = ']';

}
